//
//  alg_algorithm.h
//  TestC
//
//  Created by long yang on 2019/9/23.
//  Copyright © 2019 龙洋. All rights reserved.
//

#ifndef alg_algorithm_h
#define alg_algorithm_h

typedef struct
{
    unsigned int frame_dect_ok;    //检测帧的完整性，完整则为1，否则为0
    int frame_index;
    unsigned long  group_count;      //得到eeg的采样点组数

    double AF7_eeg_data[50];
    int AF7_leadoff_flag[50];

    double AF8_eeg_data[50];
    int AF8_leadoff_flag[50];

    int have_4sec_time_flag;    //得到4秒标志
    int time_flag_postion;        //时间标志在数据帧中的位置，如第一组时位置为0
    long time_counter;                //时间计数器
} get_eeg_info_t;

typedef struct {
    double alpha;
    double beta;
    double theta;
    double delta;
    double gamma;
}energyName;

typedef struct {
    double mindfullness; // 正念
    double focus;// 专注
    double emotion;// 情绪
    double stress; // 压力
    double fatigue;// 疲劳
    double relax; // 放松
    energyName energy;
    int isValid;
    int sqd[2];
    int sqdValid;
} algorithmTarget;

typedef struct{
    int stability; // 稳定度
    double potential; // 潜力值
    double percent; // 百分比
    int score;// 分数
} mindfulnessScore;

// 初始化方法
void initAll(void);

// 解析原始数据函数
get_eeg_info_t Split_data_frame(char *str);

// 添加设备
int add_device(char *serial);

// 删除设备
int delete_device(char * serial);

// 获取算法指标
algorithmTarget get_algorithm_result(double data_raw[58],int index);

// 获取相干性指标(传输原始值,512个AF7原始值+512个AF8原始值，128的步长，传入的len指定为512)
double get_alg_coherence(double * indata,int len);

//  获取雷达图四个指标
mindfulnessScore getMindfulnessScore(double * array,int length);
#endif /* alg_algorithm_h */

